#!/usr/bin/env python
# -*- coding: utf-8 -*-

import multiprocessing
import nnpy

print "p: Creating Socket"
cmd_socket = nnpy.Socket(nnpy.AF_SP, nnpy.REQ)
cmd_socket.bind("ipc:///tmp/nnpy-test-cmd")
print "p: Socket Created"

print "p: Sending 'start'"
cmd_socket.send("start")
print "p: 'start' sent"

print "p: Waiting to receive"
assert cmd_socket.recv() == "Starting!"
print "p: Received start confirmation"

def run_sub():
    print "p1: creating sub socket"
    sub_socket = nnpy.Socket(nnpy.AF_SP, nnpy.SUB)
    sub_socket.setsockopt(nnpy.SUB, nnpy.SUB_SUBSCRIBE, "topic:")
    sub_socket.connect("ipc:///tmp/nnpy-test-pub")
    print "p1: created sub socket"

    while True:
        print "p1: waiting on subscription"
        print "p1: received " + repr(sub_socket.recv())


print "p: creating multiprocessing child"
sub = multiprocessing.Process(target=run_sub)
sub.daemon = True
sub.start()
print "p: created multiprocessing child"

sub.join()
